#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdarg.h>
#include <sys/time.h>
#include <netdb.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

/* If there are problems and you want all x2 output to go to x2.debug, define
 * this.  It gets real big real fast....
 * #define LOGALLDEBUG 
 */

/* Define this if your using Hybrid.. tho
 * I'm not sure i'm going to really support 
 * undernet after this is completed.
 */
/* #define HYBRIDTS4  */

/* This is the CTCP charactor.  (^A)
 */
#define CTCP		'\001'
#define BOLD            '\002'
#define INVERTED        '\026'
 
/*
 * Please do not remove the name 'X2' and the version from this reply. If you 
 * make modifications please use the format: 4.4b+<yournet>.<yourversion>
 * Or, use one of the replies provided.  Obviously theres no way for me
 * to enforce this, but I have put many hundreds of hours into this program
 * and I'd like to be able to tell whos using it and what version it is based on.
 * [alternate replies]
 * #define VERSION         "X2 v5.0 - Channel and Oper services"
 * #define VERSION         "<YourNet> Channel services powered by Rubin's X2 version 5.0"
 */
#define VERSION	        "X2 v5.0.3 - AfterNET Channel Services"

#define OPERHELPFILE	"HELP/operhelp.txt"
#define USERHELPFILE	"HELP/userhelp.txt"
#define MESSAGEFILENAME "x2.news"		/* this isnt working yet.. */
#define GATEFILENAME    "wingate.log"           /* detected wingates written to disk */
#define ProcFilePath	"x2.pid"
#define AccountingLog   "accounting.log"	/* Every command is logged */
#define DefaultConfigFile "x2.conf"
#define log

/* uncomment this for debugging 
   #define debugon
*/

/* Our ircd is based on ircu, but with some big differences
 * mainly we have a usermode +g for overriding security..
 * Define this if your running AfterNet ircd, or ircd
 * that supports an ircop-only usermode +g. 
 * other nets have to /msg x2 GOD ON/OFF before ircops
 * can mess with peoples channels. */
/* Warning, ircu2.10.04 uses +g in a different way that causes
 * big security problems if this is defined! */
#define AFTERNET

/* notices makes x2 announce client connect/exit msgs in channel #notices 
 * this was added when the undernet 2.10 code didnt send them. Its been
 * fixed in .02 patches so now i disable it..*/
#undef notices

/* pinging has x2 ping the server to see if its got a dead
 * connection. this is a good idea.. */
#define pinging

/* dont touch this one.. there were bugs in the topic code but they all work fine now */
#define TOPICENABLED

#define CHANFILENAME    "chan.dat"
#define ROUTFILENAME    "ROUTES/routing.dat"
#define GLINEFILENAME   "gline.dat"
#define SUPERGLINEFILENAME "supergline.dat"

/* These are for the wingate check */
#define MAXGATESOCKS 20
#define GATECHECKTIMEOUT 60
#define GATECHECKSENDTIMEOUT 30
#define SOCKSPORT 1080
#define WAIT_TO_CONNECT 0
#define WAIT_TO_SEND  1
#define WAIT_TO_READ  2
#define WAIT_TOO_MANY 3


#define FLOODINTERVAL   6
#define PINGTIMEOUT     60
#define PINGFREQ        60
#define STRTOLSIZE      6
#define STRTOLBASE      36

/* Max number of severe errors before the bot bails */
#define MAXDBGSEVERE   5

/* The SEGSIZE options set up how big the array thats used for super fast
 * lookups of data are. They should be at least twice as big as the maximum
 * number of items that will be in the array.
 * These values work well for AfterNet, which runs just under 400 channels and
 * 200 users at peak time.  The bot will notify you via wallops if these need
 * to be increased.  Small values only hurt performance, everything will remain functional. */
#define CHANSEGSIZE     3001
#define USERSEGSIZE     3001
#define SERVERSEGSIZE   61
#define ROUTSEGSIZE     SERVERSEGSIZE
#define NETSEGSIZE      41
#define NETLINKSEGSIZE  21
#define OPERSEGSIZE     401
#define SERVNAMESEGSIZE 21
#define NETCHANMAXSIZE  21

#define MAXCHANLISTLEN  500
/* Make sure this is larger then your newtworks nicks.. default is 9. afternet runs 15. */
#define MAXNICKLEN	30
#define MAXCIDLEN       10      /* TS4 Connection ID (no idea whats reasonable */
#define PASSWORDLEN     10      /* Some bugs with long passwords have
                                   been reported. This should solve it.. */
#define MAXPASS         200	/* Also for ban <Reason> so make it big */
#define MAXINFOLEN      160     /* Info Lines */
#define MAXNUMOFARGS	80
#define MAXLEN		540	/* used all over.. set it pretty big */
#define MAXCHANLEN	256	/* this must be >= what ircd has */
#define MAXSERVERLEN    500     /* Longest length a servername will have */
#define MAXCHANKEY      56

#define MAXCONFSTRBUFF  256
/* bringing linebuff up from 128 to 512 to solv posible
   topic overflow problems. */
//#define LINEBUFFSIZE    512
#define LINEBUFFSIZE    2048  /* Must be enough to hold 
				 topic and description etc */
/* TOPIC LENGTH NOT TO EXCEDE LINEBUFFSIZE!!! */
#define MAXTOPICLEN	160
#define MAXURLLEN       160
#define MAXDESCLEN      500
#define INBUFFSIZE      1024
#define MAXLINES        (INBUFFSIZE/10)
#define LINETRUNKSIZE   200
#define MAXRECVLEN      2000
#define MAXLINELEN      300

/* Channels unvisited by (co)owner will be automatically 
 * removed when they reach this many days old.
 */
#define CHANEXPIREDAYS  30

/* These are for channel mode parsing */
#define NOMODES         0
#define CMODEn          128
#define CMODEt          64
#define CMODEs          32
#define CMODEp          16
#define CMODEi          8
#define CMODEl          4
#define CMODEk          2
#define CMODEm          1

/* These are for User mode parsing.. */
#define UMODEaway       512
#define UMODEgod        256
#define UMODEx          128
#define UMODEs          64
#define UMODEk          32
#define UMODEo          16
#define UMODEd          8
#define UMODEw          4
#define UMODEi          2
#define UMODEg          1

/* in parse.c the command paramiter from the
 * server is converted to an int. These
 * have been pre-calculated to match.. thus
 * switch() can be used on strings (:
 * I realize how annoying this is to add 
 * onto.. but its not hard to write 
 * a quick c function to make new ones.
 */
#define NICK		1096868l
#define SERVER		1717867971l
#define MODE		1058018l
#define JOIN		918239l
#define PART		1180361
#define KICK		956900l
#define SQUIT		48281861l
#define PRIVMS	        1557884836l
#define QUIT		1252613l
#define KILL            957225l

/* These are numerics.. i think */
#define INVITEONLY	473
#define BANNED		474
#define JOINED		353

/* These are the various debug levels.. */

#define DBGNOTICE   10
#define DBGINFO     20
#define DBGWARNING  30
#define DBGERROR    40
#define DBGSEVERE   50

#define SEPERATORS  ".,;\n "
#define null(type) (type) 0L
#ifndef NULL
#define NULL(type) (type)0
#endif
#ifndef TRUE
#define TRUE     1
#define FALSE    0
#endif

#define Reg1 register

typedef struct set_listType
{
  char *name;
  int index;
  int user;   /* Is it a user modifyable thing */
  int min;
  int max;
  int def;
  char *description;
  char *pre;
  char settings[6][150];
} set_list;

typedef enum
{
  false, true
}
boolean;

typedef struct NetMessageStruct
{
  time_t Timestamp;
}
NetMessageType;

typedef struct OperStruct
{
  char *Address;
  char Pass[MAXPASS];
  char Handle[20];
  char Info[200];
  int AutoOp;
  time_t LastSeen;
  int inchan;
  struct OperStruct *Next;
}
*OperListType;

typedef struct OperSegStruct
{
  OperListType Table[OPERSEGSIZE];
  struct OperSegStruct *Next;
}
*OperSegment;

typedef struct FloodStruct
{
  char Nick[MAXNICKLEN];
  time_t Stamp;
}
*FloodListType;

typedef struct UserHostType
{
  char name[100];
  char channel[100];
  time_t time;
  time_t kicktime, bantime, deoptime, killtime;
  int bannum, deopnum, kicknum;
  int totmsg, msgnum;
  int totop, totban, totdeop, totkick, totkill;
  struct UserHostType *next;
}
UserHostStruct;

typedef struct BAN_struct
{
  char banstring[MAXLEN];	/* banned nick!user@host */
  time_t time;
  struct BAN_struct *next;	/* Next ban */
}
BAN_list;


typedef struct GlineStruct
{
  char address[MAXLEN];		/* User@Host */
  char reason[MAXLEN];		/* <Nick> ... */
  time_t time;
  struct GlineStruct *Next;
}
GlineListType;

typedef struct ShitType
{
  char userhost[MAXLEN];	/* Nick!User@Host */
  int level;			/* Access level or ShitLevel */
  struct ListType *channels;
  struct ShitType *next;	/* next user */
}
ShitStruct;

/* This defines which element of the set array is which setting.
 * It doesnt matter as long as there all different.  could have 
 * used enum here i know.. Be sure to modify NUMOFCHANSETTINGS below */
#define TOPICFREQ   0
#define STRICTOP    1
#define AUTOOP      2
#define PROTECT     3
#define ENFMODES    4
#define PASSMODE    5
#define BANTIMEOUT  6
#define VOICE       7
#define USERINFO    8
#define INCHAN      9
#define SUSPENDED   10
#define NODELETE    11

/* This MUST be right or a crash or file corruption may result!
 * this INCLUDES the 0th setting. (0-11 would be 12) */
#define NUMOFCHANSETTINGS 12

typedef struct ChanStruct
{
  char *Name;			/* n t s p i l k m = modes */
  unsigned char Modes:8;	/* 0 0 0 0 0 0 0 0 = bits */
  char *Topic;			/* 8 7 6 5 4 3 2 1 = bit position */
  char *Description;
  char *URL;
  char *Reggedby;
  int NumOfOps;
  int OwnersOnline;
  OperSegment Opers;
  int settings[NUMOFCHANSETTINGS];
  int PlusModes;
  int MinModes;
  char *Key;
  char *Limit;
  char CurrentKey[MAXCHANKEY];
  time_t LastAccess;
  time_t CreationDate;
  BAN_list *banned;
  struct ChanStruct *Next;
}
*ChannelListType;

typedef struct ChanSegStruct
{
  ChannelListType Table[CHANSEGSIZE];
  struct ChanSegStruct *Next;
}
*ChanSegment;

typedef struct ServStruct
{
  char *Name;
  char *LinkName;
  char *Description;
  int NumOfUsers;
  int Deleted;
  struct ServStruct *Next;
}
*ServerListType;


typedef struct ServSegStruct
{
  ServerListType Table[SERVERSEGSIZE];
  struct ServStruct *Next;
}
*ServSegment;

typedef struct OwnerStruct
{
  char *Channel;
  struct OwnerStruct *Next;
}
*OwnerListType;

typedef struct UserStruct
{
  char Nick[MAXNICKLEN];
  char CID[MAXCIDLEN];
  char UserID[12];
  char *Address;
  char IP[50];
  char *Validated;
  char *RealName;
  char *Serv;
  OwnerListType Chans;
  int Clones;
#ifdef HYBRIDTS4                /* Hybrid has more modes.. */
  unsigned int Modes:13;        /* o i w s z c r k f d K g AWAY*/
#else
                                /*god x k o s w i g AWAY = flags */
  unsigned int Modes:10;        /* 0  0 0 0 0 0 0 0 0 = bits */
#endif
  struct UserStruct *NextA;
  struct UserStruct *NextN;
#ifdef HYBRIDTS4
  struct UserStruct *NextC;
#endif
}
*UserListType;

typedef struct UserSegStruct
{
  UserListType Table[USERSEGSIZE];
  struct UserSegStruct *Next;
}
*UserSegment;

typedef struct ServNameStruct
{
  char *ServName;
  struct ServNameStruct *Next;
}
*ServNameListType;

typedef struct ServNameSegStruct
{
  ServNameListType Table[SERVNAMESEGSIZE];
  struct ServNameSegStruct *Next;
}
*ServNameSegment;

typedef struct NetStruct
{
  char *Name;
  ServNameSegment ServNames;
  int NumOfServs;
  struct NetStruct *Next;
}
*NetListType;

typedef struct NetSegStruct
{
  NetListType Table[NETSEGSIZE];
  struct NetSegStruct *Next;
}
*NetSegment;

typedef struct NetLinkStruct
{
  int Socket;
  char *NetName;
  unsigned char NumOfChans;
  char *ChanList[NETCHANMAXSIZE];
  struct NetLinkStruct *Next;
}
*NetLinkListType;

typedef struct NetLinkSegStruct
{
  NetLinkListType Table[NETLINKSEGSIZE];
  struct NetLinkSegStruct *Next;
}
*NetLinkSegment;

typedef struct UpLinkSegStruct
{
   char ServName[MAXLEN];
   char ServIp[MAXLEN];
   char ServPass[20];
   int  Port;
   struct UpLinkSegStruct *Next;
}
UpLinkList;

typedef struct GateListStruct 
{
        char nick[MAXLEN];           /* nick of the user */
        char iphost[MAXLEN];         /* userip reply ip address */
        int sock;           /* our socket connection */
        time_t timestamp;            /* The timestamp */
        int delete;                  /* is this entry deleted? */
        int state;                   /* stage of connection (Wait to send/read) */
        struct GateListStruct *next; /* The next one...*/
}
GateListType;

extern UpLinkList *UpLinks;
extern boolean AUTOROUTING, AUTOCONNECT, ENFORCEOPS, PINGOUTCONNECT, GATECHECK,
               FLOODCONTROL, NETLINK, NETTALK, PUBLIC, NETBURSTING;
extern unsigned char CLONERES, MAXCLONES, MAXCHAN, DEBUG;

extern char DBTARGET[MAXLEN];

extern char DefServHost[MAXLEN], ServiceName[MAXLEN],
            Uplink[MAXLEN], ServAddress[16], Password[20], 
            IrcNick[MAXNICKLEN], 
#ifdef HYBRIDTS4
            IrcCID[MAXCIDLEN], 
#endif
            CommandMark, HomeDir[MAXLEN];

#ifndef HYBRIDTS4
#define IrcCID IrcNick
#endif /* HYBRIDTS4 */

extern u_short Port, SERVERPORT;
extern int Sock, NewSock;
extern struct sockaddr_in ServAddr, CliAddr;
extern fd_set fdvar, wfdvar;
extern int MaxSock;

extern boolean SockConnected;
extern boolean ServerConnected;
extern boolean SentBurst, Authenticated;
extern boolean RoutsOk;
extern boolean GotPong;

extern time_t LinkTimeStamp, ServerTimeStamp, ConnectTime, StartTime, DiscTime,
              PingStamp, PongStamp, FloodStamp;
extern long int NetOffset;
extern time_t bantimer;

extern char LastNickAdded[MAXNICKLEN];
extern char LastRequestNick[MAXNICKLEN];

extern ChanSegment Channels;
extern GlineListType *Glines;
extern GlineListType *SuperGlines;
extern ServSegment Servers, Routs;
extern UserSegment UsersN, UsersA;

#ifdef HYBRIDTS4
extern UserSegment UsersC;
#endif /* HYBRIDTS4 */

extern NetSegment Nets;
extern NetLinkSegment NetLinks;
extern NetMessageType NetMessage;
extern UpLinkList *CurUpLink;
extern GateListType *GatePtrs;

extern int ChannelCount, ServerCount, RoutCount, UserCount, OperCount,
           PeonCount, OpCount, ManagerCount, CoOwnerCount, OwnerCount, LamerCount;
