/*
 *    X2  IRC Operator and Channel services
 *    by Rubin (rubin@afternet.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "config.h"
#include "sock.h"

OperSegment InitOperSeg(OperSegment NewOpers)
{

  int i;

  NewOpers = (OperSegment) malloc(sizeof(struct OperSegStruct));

  if (!NewOpers)
    return (NULL);
  NewOpers->Next = NULL;
  for (i = 0; i < OPERSEGSIZE; i++)
    NewOpers->Table[i] = NULL;
  return (NewOpers);
}

ServNameSegment InitServNameSeg(ServNameSegment NewServNames)
{

  int i;

  NewServNames = (ServNameSegment) malloc(sizeof(struct ServNameSegStruct));

  if (!NewServNames)
    return (NULL);
  NewServNames->Next = NULL;
  for (i = 0; i < SERVNAMESEGSIZE; i++)
    NewServNames->Table[i] = NULL;
  return (NewServNames);
}
ServSegment InitServSeg(ServSegment NewServers)
{

  int i;
  NewServers = (ServSegment) malloc(sizeof(struct ServSegStruct));

  if (!NewServers)
    return (NULL);
  NewServers->Next = NULL;
  for (i = 0; i < SERVERSEGSIZE; i++)
    NewServers->Table[i] = NULL;
  return (NewServers);
}


UserSegment InitUserSeg(UserSegment NewUsers)
{

  int i;

  NewUsers = (UserSegment) malloc(sizeof(struct UserSegStruct));

  if (!NewUsers)
    return (NULL);
  NewUsers->Next = NULL;
  for (i = 0; i < USERSEGSIZE; i++)
    NewUsers->Table[i] = NULL;
  return (NewUsers);
}

ChanSegment InitChanSeg(ChanSegment NewChannels)
{

  int i;

  NETBURSTING = TRUE;
  NewChannels = (ChanSegment) malloc(sizeof(struct ChanSegStruct));

  if (!NewChannels)
    return (NULL);
  NewChannels->Next = NULL;
  for (i = 0; i < CHANSEGSIZE; i++)
    NewChannels->Table[i] = NULL;
  return (NewChannels);
}

NetSegment InitNetSeg(NetSegment NewNets)
{

  int i;

  NewNets = (NetSegment) malloc(sizeof(struct NetSegStruct));

  if (!NewNets)
    return (NULL);
  NewNets->Next = NULL;
  for (i = 0; i < NETSEGSIZE; i++)
    NewNets->Table[i] = NULL;
  return (NewNets);
}

NetLinkSegment InitNetLinkSeg(NetLinkSegment NewNetLinks)
{

  int i;

  NewNetLinks = (NetLinkSegment) malloc(sizeof(struct NetLinkSegStruct));

  if (!NewNetLinks)
    return (NULL);
  NewNetLinks->Next = NULL;
  for (i = 0; i < NETLINKSEGSIZE; i++)
    NewNetLinks->Table[i] = NULL;
  return (NewNetLinks);
}


int InitGlobals()
{

  ChannelCount = 0;
  ServerCount = 0;
  RoutCount = 0;
  UserCount = 0;
  OperCount = 0;
  PeonCount = 0;
  OpCount = 0;
  ManagerCount = 0;
  CoOwnerCount = 0;
  OwnerCount = 0;
  MaxSock = 0;
  RoutsOk = false;
  LastNickAdded[0] = '\0';
  Glines = NULL;
  SuperGlines = NULL;
  GatePtrs = NULL;

  strcpy(DBTARGET, "");
  DEBUG = 20;			/* INFO and higher */
  if (!(Servers = InitServSeg(Servers)))
    return (0);
  if (!(UsersN = InitUserSeg(UsersN)))
    return (0);
  if (!(UsersA = InitUserSeg(UsersA)))
    return (0);
#ifdef HYBRIDTS4
  if (!(UsersC = InitUserSeg(UsersC)))
    return (0);
#endif /* HYBRIDTS4 */
  if (!(Channels = InitChanSeg(Channels)))
    return (0);
  if (!(Routs = InitServSeg(Routs)))
    return (0);

  srand(time(NULL));
  return (1);
}

void Authenticate(UpLinkList *UpLinkPtr)
{

/* This is now done in parse.c 
 * AddServer(Uplink,ServiceName);
 */

/* This shouldnt be here but it meets the requirements so what the hell.. */
#ifdef HYBRIDTS4
  strcpy(IrcCID, ".X2CID001");
#else
  strcpy(IrcCID, IrcNick);
#endif /* HYBRIDTS4 */
 
  ConnectTime = ServerTimeStamp = time(NULL);
  sendtosock(Sock, "PASS :%s", UpLinkPtr->ServPass);
  LinkTimeStamp = NetTime()- 10000;
#ifdef HYBRIDTS4
  sendtosock(Sock, "SVINFO 4 4 0 :%lu", time(NULL));
  sendtosock(Sock, "CAPAB :TS4");
  sendtosock(Sock, "SERVER %s 1 :X2 Channel Services: http://www.afternet.org/x2/", ServiceName);
  sendtosock(Sock, "CLIENT %s %lu %s %d %s %s %s :%s", 
                   IrcCID, LinkTimeStamp, IrcNick, 1, "+okK", IrcNick, ServiceName, "/msg X2 help");
#else  /* HYBRIDTS4 */
  sendtosock(Sock, "SERVER %s 1 %lu %lu J09 %s", ServiceName, LinkTimeStamp, ServerTimeStamp, 
                                         "X2 Channel Service: http://www.afternet.org/x2/");
  sendtosock(Sock, "NICK %s 1 %lu %s %s %s :\002%c\002) /MSG %s Help (\002%c\002", IrcNick, 0, IrcNick, ServiceName, ServiceName, CommandMark, IrcNick, CommandMark);
  sendtosock(Sock, ":%s MODE %s +ko", IrcNick, IrcNick);
#endif  /* HYBRIDTS4 */
  sendtosock(Sock, "PING :%s", Uplink);
#ifdef pinging
  PingStamp = time(NULL);
  GotPong = false;
#endif
}

void JoinChans()
{
  char ChanModes[50];
  char ModeString[LINEBUFFSIZE];
  int i;
  ChannelListType TempChanPtr;

  for (i = 0; i < CHANSEGSIZE; i++)
  {
    if (Channels->Table[i])
    {
      TempChanPtr = Channels->Table[i];
      while (TempChanPtr && SockConnected)
      {
        if(TempChanPtr->settings[INCHAN])
        {
#ifdef HYBRIDTS4
           sendtosock(Sock, ":%s SJOIN %lu %s %s :@%s", ServiceName, TempChanPtr->CreationDate, 
               TempChanPtr->Name, 
               GetModeString(ModeString, TempChanPtr->PlusModes, 0, TempChanPtr->Key, TempChanPtr->Limit), 
               IrcCID);
#else  /* HYBRIDTS4 */
    	   sendtosock(Sock, ":%s JOIN %s", IrcNick, TempChanPtr->Name);
	   sendtosock(Sock, ":%s MODE %s + %lu", ServiceName, TempChanPtr->Name, TempChanPtr->CreationDate);
	   sendtosock(Sock, ":%s MODE %s +o %s 0", ServiceName, TempChanPtr->Name, IrcNick);
	   sendtosock(Sock, ":%s MODE %s %s", IrcNick, TempChanPtr->Name, 
                      GetModeString(ModeString, TempChanPtr->PlusModes,
                      TempChanPtr->MinModes, TempChanPtr->Key,
                      TempChanPtr->Limit));
#endif /* else HYBRIDTS4 */

	   if (strcmp(TempChanPtr->Topic, "*") && (TempChanPtr->settings[TOPICFREQ] > 0))
	     sendtosock(Sock, ":%s TOPIC %s :%s", IrcNick, TempChanPtr->Name, TempChanPtr->Topic);
        }
	TempChanPtr = TempChanPtr->Next;
      }
    }
  }
}

void ResetTopics()
{
  char ChanModes[50];
  int i;
  ChannelListType TempChanPtr;

  for (i = 0; i < CHANSEGSIZE; i++)
  {
    if (Channels->Table[i])
    {
      TempChanPtr = Channels->Table[i];
      while (TempChanPtr)
      {
	if(TempChanPtr->settings[TOPICFREQ] && strcmp(TempChanPtr->Topic, "*"))
	  sendtosock(Sock, ":%s TOPIC %s :%s", IrcNick, TempChanPtr->Name, TempChanPtr->Topic);

	TempChanPtr = TempChanPtr->Next;
      }
    }
  }
}
