
/*
 *    X2  IRC Operator and Channel services
 *    by Rubin (rubin@afternet.org)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "config.h"

int my_init_client(char *DefServHost, u_short Port)
{

  int Sckt;
  register struct hostent *hostptr;

  hostptr = gethostbyname(DefServHost);
  if (!hostptr)
    return (-1);
  bzero((char *) &ServAddr, sizeof(ServAddr));
  memcpy(&(ServAddr.sin_addr.s_addr), hostptr->h_addr_list[0], (size_t) hostptr->h_length);
  ServAddr.sin_family = AF_INET;
  ServAddr.sin_port = htons(Port);

  Sckt = socket(AF_INET, SOCK_STREAM, 0);
  if (Sckt >= 0)
    if (connect(Sckt, (struct sockaddr *) &ServAddr, sizeof(ServAddr)) >= 0)
    {
      if (Sckt > MaxSock)
	MaxSock = Sckt;
      SockConnected = true;
      return (Sckt);
    }
  return (-1);
}

int my_init_server()
{
  int Sckt = 99999, NewSckt;
  int CliLen;
  int reuse_addr = 1;

  Debug(DBGINFO, "Beginning init_server() %d", SERVERPORT);
  CliLen = sizeof(CliAddr);
  Sckt = socket(AF_INET, SOCK_STREAM, 0);
  setsockopt(Sckt, SOL_SOCKET, SO_REUSEADDR,&reuse_addr,sizeof(reuse_addr));

  bzero((char *) &ServAddr, sizeof(ServAddr));
  ServAddr.sin_family = AF_INET;
  ServAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  ServAddr.sin_port = htons(SERVERPORT);
  bind(Sckt, (struct sockaddr *) &ServAddr, sizeof(ServAddr));
  if(listen(Sckt, 5) == -1)
  {
     Debug(DBGINFO, "Error in listen()");
     exit(1);
  }
  Debug(DBGINFO, "Waiting for accept() to finish.. Sckt == %d", Sckt);
  NewSckt = accept(Sckt, (struct sockaddr *) &CliAddr, &CliLen);
  Debug(DBGINFO, "Completed accept() continuing..");
  close(Sckt);
  MaxSock = NewSckt;
  SockConnected = true;
  return (NewSckt);
}


int writen(register int fd, register char *ptr, register int nbytes)
{

  int nleft, nwritten;

  nleft = nbytes;
  while (nleft > 0)
  {
    nwritten = write(fd, ptr, nleft);
    if (nwritten <= 0)
      return (nwritten);

    nleft -= nwritten;
    ptr += nwritten;
  }

  return (nbytes - nleft);
}

int sendtosockDEBUG(int fd, char *fmt,...)
{
  char buff[MAXLEN*4];
  int n;
  va_list args;
  fd_set wfdvar;
  static struct timeval timeout;

  if ((fd == Sock) && !SockConnected)
  {
    return (0);
  }
  FD_ZERO(&wfdvar);
  FD_SET(fd, &wfdvar);
  timeout.tv_sec = 1l;
  timeout.tv_usec = 0l;
  va_start(args, fmt);
  vsnprintf(buff, MAXLEN, fmt, args);
  va_end(args);
  n = strlen(buff);
  buff[n] = '\n';
  n++;
  select(fd + 1, NULL, &wfdvar, NULL, &timeout);
  if (FD_ISSET(fd, &wfdvar))
  {
    if ((writen(fd, buff, n)) != n)
      return (0);
  }
  else
    return (0);
  return (1);
}

int sendtosock(int fd, char *fmt,...)
{

  char buff[MAXLEN*4];
  int n;
  int we;
  va_list args;
  fd_set wfdvar;
  static struct timeval timeout;

  if ((fd == Sock) && !SockConnected)
    return (0);
  FD_ZERO(&wfdvar);
  FD_SET(fd, &wfdvar);
  timeout.tv_sec = 1l;
  timeout.tv_usec = 0l;
  va_start(args, fmt);
  vsnprintf(buff, MAXLEN, fmt, args);
  va_end(args);
  Debug(DBGNOTICE, "-> %s\n", buff);

  n = strlen(buff);
  buff[n] = '\n';
  n++;
  select(fd + 1, NULL, &wfdvar, NULL, &timeout);
  if (FD_ISSET(fd, &wfdvar))
  {
    if ((we = writen(fd, buff, n)) != n)
    {
      if ((we == -1) && (fd == Sock))
      {
        SockConnected = FALSE;
	Debug(DBGSEVERE, "write to main socket returned neg 1. did we have a problem? breaking connection..");

      }
      return (0);
    }
  }
  else
    return (0);
  return (1);
}


/* netlink no longer exists.. 
   void RemoveSock(int DeadSock) {

   int i;
   NetLinkListType NLNode;

   if (MaxSock == DeadSock)
   MaxSock--;
   for (i=0;i<NETLINKSEGSIZE;i++) {
   NLNode = NetLinks->Table[i];
   while (NLNode) {
   if (NLNode->Socket == DeadSock) {
   DeleteNetLink(NLNode->NetName);
   return;
   }
   NLNode = NLNode->Next;
   }    
   }
   }
 */
/* this too.
   void CloseAllSocks()
   {

   int i;
   NetLinkListType NetLinkPtr,TempPtr;

   close(Sock);
   MaxSock=0;

   for (i=0;i<NETLINKSEGSIZE;i++) {
   NetLinkPtr = NetLinks->Table[i];
   while (NetLinkPtr) {
   close(NetLinkPtr->Socket);
   TempPtr = NetLinkPtr;
   NetLinkPtr = NetLinkPtr->Next;
   DeleteNetLink(TempPtr->NetName);
   } 
   }
   NetLinkCount = 0;
   }
 */
void SelectSockets()
{
  GateListType *GatePtr;

  FD_ZERO(&fdvar);
  FD_ZERO(&wfdvar);
  FD_SET(Sock, &fdvar);
  MaxSock = Sock;

  for(GatePtr=GatePtrs;GatePtr;GatePtr=GatePtr->next)
  {
     if(GatePtr->delete == TRUE)
     {
     }
     else if(GatePtr->state == WAIT_TO_CONNECT || GatePtr->state == WAIT_TO_SEND)
     {
         FD_SET(GatePtr->sock, &wfdvar);
         if(MaxSock < GatePtr->sock)
               MaxSock = GatePtr->sock;
     }
     else if(GatePtr->state == WAIT_TO_READ)
     {
         FD_SET(GatePtr->sock, &fdvar);
         if(MaxSock < GatePtr->sock)
               MaxSock = GatePtr->sock;

     }
  }
}


int TryToConnect(UpLinkList *UpLinkPtr)
{
  int i;
  ServerListType TempRoutPtr;

  SockConnected = false;

  if ((Sock = my_init_client(UpLinkPtr->ServIp, UpLinkPtr->Port)) != -1)
  {
     strcpy(Uplink, UpLinkPtr->ServName);
     SockConnected = true;
  }
  return (SockConnected);
}
